#! /usr/bin/gforth b16-asm.fs
\ -*- forth-mode -*-
\ $Log: test.asm,v $
\ Revision 1.2  2004/02/18 16:11:25  berndp
\ Mostly working version (excluding SFRs to analog part)
\
\ Revision 1.1  2004/02/06 14:59:16  berndp
\ Self test first checkin
\
$400 org
: reset			\ label reset
    fw jmp		\ jump forward to boot
: error  BEGIN  jmp
: stack			\ stack test
    1 #c 2 #c 3 #	\ fill stack with 1 2 3 4 5 6 7 8 9 A B
    4 # 5 #c 6 #c
    7 #c 8 #c 9 #
    $A # $B # nop
    + + +
    + + +
    + + +
    + $62 # xor IF  error  THEN \ !!! this checks stack depth, too !!!
;			\ return to caller
: alu			\ test ALU
    $1234 # $5678 # +	\ add two literals
    dup $68AC # xor IF  error  THEN
    $1234 # com +c	\ complement and add with carry = subtract
    $5678 # xor IF  error  THEN
    $1234 # $5678 # or	\ OR two literals
    dup $567C # xor IF  error  THEN
    $1234 # $5678 # and	\ AND two literals
    dup $1230 # xor IF  error  THEN
    xor	\ XOR the two results from above, and drop results
    $444C # xor IF  error  THEN
;			\ return to caller
: jumps			\ test a few jumps
    0 #c 1 #c    -IF  drop 3 # + THEN  drop \ jump if non-zero
    0 #c 0 #c     IF  drop 4 # + THEN  drop \ jump if zero
    0 # com     -cIF  drop 5 # + THEN  drop \ jump if carry
    0 #c 0 #c +  cIF  drop 6 # + THEN  drop \ jump if no carry
;			\ return to caller
: -jumps		\ test a few jumps the other way round
    0 #c 1 #c     IF  drop 3 # + THEN
    0 #c 0 #c    -IF  drop 4 # + THEN
    0 # com      cIF  drop 5 # + THEN
    0 #c 0 #c + -cIF  drop 6 # + THEN
;			\ return to caller
: stackop
    1 #c 2 #c dup >r over >r over over + >r
    r> + r> + r> + +
    9 # xor IF  error  THEN ;
: loadstore
    $5678 # $1234 # 0 # !+ !+ drop
    0 # @+ @+ drop +
    dup $68AC # xor IF  error  THEN
    $1234 # 4 # !+ drop
    4 # c@+ c@+ drop +
    dup $46 # xor  IF error  THEN
;
: boot THEN		\ resolve forward jump from reset
    BEGIN stack		\ call stack test
	alu			\ call ALU test
	jumps -jumps	\ call jump tests
	loadstore           \ call load store tests
	stackop
	$F000 # $0202 # !* drop
	$0000 # $0200 # !* drop
    jmp ;		\ endless loop
$400 $400 .hex test.hex	\ print intel hex for $400 bytes
.mif test.mif
.end			\ end of test program
